
#define ERR_GENERIC   0x00
#define ERR_OPENIMAGE 0x01
#define ERR_SAVETRACK 0x02
#define ERR_READIMAGE 0x03

typedef struct image_s
       {
       long               header_offset;
       long               header_position;
       long               length;
       unsigned long      version;
       unsigned short int sessions;
       unsigned short int tracks;
       unsigned short int remaining_sessions;
       unsigned short int remaining_tracks;
       unsigned short int global_current_session;
       } image_s;

typedef struct track_s
       {
       unsigned short int global_current_track;
       unsigned short int number;
       long               position;
       unsigned long      mode;
       unsigned long      sector_size;
       unsigned long      sector_size_value;
       unsigned long      length;
       unsigned long      pregap_length;
       unsigned long      total_length;
       unsigned long      start_lba;
       unsigned char      filename_length;
       } track_s;

typedef struct opts_s
       {
       char showinfo;
       char cutfirst;
       char cutall;
       char convert;
       char fulldata;
       char rawaudio;
       char swap;
       char ask_for_image;
       char do_cut;
       char do_convert;
       char create_cuesheet;
       char save_as_iso;
       } opts_s;


void savetrack(FILE *fsource, track_s *, opts_s *);
void savecuesheet(FILE *fcuesheet, track_s *, opts_s *);

void writewavheader(FILE *fdest, unsigned long track_length);
unsigned long ask_type(FILE *fsource, long header_position);

void error_exit(long errcode, char *string);
int askfilename(char *string);

void show_counter(unsigned long i, unsigned long track_length, unsigned long image_length, long pos);

